/* ========================================
 *
 * Copyright CONSULTRON, 2020
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONSULTRON allows PUBLIC use of the file.
 * CONSULTRON provides NO WARRANTY expressed or implied.
v *
 * ========================================
Module: `$INSTANCE_NAME`.h
Module Build: `$CY_MAJOR_VERSION`.`$CY_MINOR_VERSION`.3
Module Comment: `$CY_COMMENT`

•	2.0.0 - Convert: Code rewritten as a configurable component.  
	- Add: Term to Term_UART call defines.
•	2.2.0 - Improved Support for UART v2_50 base functions 
•	2.2.1 - Added: Embedded MenuCmds and String_Funcs components
•	2.2.2 - Added: User selectable MenuCmds and String_Funcs components
•	2.2.3 - Fix: Calls to USBUART functions in `$INSTANCE_NAME`.c and `$INSTANCE_NAME`.h
*/
/***************************************************************
See operational description in UART_USB.c 
*/
#if !defined(`$INSTANCE_NAME`_H)	// Only allow if this header is not already defined.
#define `$INSTANCE_NAME`_H				// define that this files has been called already in the precompile phase
#include <project.h>
	
void `$INSTANCE_NAME`_Start();
#define ENABLE_STRING_FUNCS		`$Enable_String_Funcs`
#define ENABLE_MENUCMDS			`$Enable_MenuCmds`

// Conversion of Term calls to UART calls.
	#if defined(CY_UART_`$INSTANCE_NAME`_UART_H)	// Only allow the defines and prototypes below if UART.h is not defined.
// defines for Function-redirects specific to the UART component
#define `$INSTANCE_NAME`_Stop 					`$INSTANCE_NAME`_UART_Stop
#define `$INSTANCE_NAME`_ReadControlRegister 	`$INSTANCE_NAME`_UART_ReadControlRegister
#define `$INSTANCE_NAME`_WriteControlRegister 	`$INSTANCE_NAME`_UART_WriteControlRegister

#define `$INSTANCE_NAME`_Init 					`$INSTANCE_NAME`_UART_Init
#define `$INSTANCE_NAME`_Enable 				`$INSTANCE_NAME`_UART_Enable
#define `$INSTANCE_NAME`_SaveConfig 			`$INSTANCE_NAME`_UART_SaveConfig
#define `$INSTANCE_NAME`_RestoreConfig 			`$INSTANCE_NAME`_UART_RestoreConfig
#define `$INSTANCE_NAME`_Sleep 					`$INSTANCE_NAME`_UART_Sleep
#define `$INSTANCE_NAME`_Wakeup					`$INSTANCE_NAME`_UART_Wakeup

#define `$INSTANCE_NAME`_EnableRxInt 			`$INSTANCE_NAME`_UART_EnableRxInt
#define `$INSTANCE_NAME`_DisableRxInt 			`$INSTANCE_NAME`_UART_DisableRxInt
#define `$INSTANCE_NAME`_RXISR 					`$INSTANCE_NAME`_UART_RXISR
#define  `$INSTANCE_NAME`_SetRxAddressMode 		`$INSTANCE_NAME`_UART_SetRxAddressMode
                                                                                    
#define  `$INSTANCE_NAME`_SetRxAddress1			`$INSTANCE_NAME`_UART_SetRxAddress1
#define  `$INSTANCE_NAME`_SetRxAddress2			`$INSTANCE_NAME`_UART_SetRxAddress2

#define  `$INSTANCE_NAME`_SetRxInterruptMode	`$INSTANCE_NAME`_UART_SetRxInterruptMode
#define  `$INSTANCE_NAME`_ReadRxData 			`$INSTANCE_NAME`_UART_ReadRxData
#define  `$INSTANCE_NAME`_ReadRxStatus 			`$INSTANCE_NAME`_UART_ReadRxStatus
#define  `$INSTANCE_NAME`_GetChar 				`$INSTANCE_NAME`_UART_GetChar
#define  `$INSTANCE_NAME`_GetByte 				`$INSTANCE_NAME`_UART_GetByte
#define  `$INSTANCE_NAME`_GetRxBufferSize 		`$INSTANCE_NAME`_UART_GetRxBufferSize

#define  `$INSTANCE_NAME`_ClearRxBuffer 		`$INSTANCE_NAME`_UART_ClearRxBuffer

/* Obsolete functions, defines for backward compatible */
#define `$INSTANCE_NAME`_GetRxInterruptSource	`$INSTANCE_NAME`_UART_GetRxInterruptSource

#define `$INSTANCE_NAME`_EnableTxInt			`$INSTANCE_NAME`_UART_EnableTxInt
#define `$INSTANCE_NAME`_DisableTxInt			`$INSTANCE_NAME`_UART_DisableTxInt
#define `$INSTANCE_NAME`_SetPendingTxInt		`$INSTANCE_NAME`_UART_SetPendingTxInt
#define `$INSTANCE_NAME`_ClearPendingTxInt		`$INSTANCE_NAME`_UART_ClearPendingTxInt
#define `$INSTANCE_NAME`_TXISR					`$INSTANCE_NAME`_UART_TXISR
												
#define `$INSTANCE_NAME`_SetTxInterruptMode		`$INSTANCE_NAME`_UART_SetTxInterruptMode
#define `$INSTANCE_NAME`_WriteTxData			`$INSTANCE_NAME`_UART_WriteTxData
#define `$INSTANCE_NAME`_ReadTxStatus			`$INSTANCE_NAME`_UART_ReadTxStatus
#define `$INSTANCE_NAME`_PutChar				`$INSTANCE_NAME`_UART_PutChar
#define `$INSTANCE_NAME`_PutString				`$INSTANCE_NAME`_UART_PutString
#define `$INSTANCE_NAME`_PutArray				`$INSTANCE_NAME`_UART_PutArray
												
#define `$INSTANCE_NAME`_PutCRLF				`$INSTANCE_NAME`_UART_PutCRLF
#define `$INSTANCE_NAME`_ClearTxBuffer			`$INSTANCE_NAME`_UART_ClearTxBuffer
#define `$INSTANCE_NAME`_SetTxAddressMode		`$INSTANCE_NAME`_UART_SetTxAddressMode
#define `$INSTANCE_NAME`_SendBreak				`$INSTANCE_NAME`_UART_SendBreak
#define `$INSTANCE_NAME`_GetTxBufferSize 		`$INSTANCE_NAME`_UART_GetTxBufferSize

/* Obsolete functions, defines for backward compatible */
#define `$INSTANCE_NAME`_PutStringConst       	`$INSTANCE_NAME`_UART_PutStringConst      
#define `$INSTANCE_NAME`_PutArrayConst        	`$INSTANCE_NAME`_UART_PutArrayConst       
#define `$INSTANCE_NAME`_GetTxInterruptSource 	`$INSTANCE_NAME`_UART_GetTxInterruptSource

#define `$INSTANCE_NAME`_LoadRxConfig			`$INSTANCE_NAME`_UART_LoadRxConfig
#define `$INSTANCE_NAME`_LoadTxConfig			`$INSTANCE_NAME`_UART_LoadTxConfig
	
// More #defines substitution can be added later as needed
	#endif	//	#if defined(CY_UART_`$INSTANCE_NAME`_UART_H)	// Only allow the defines and prototypes below if UART.h is not defined.

// Conversion of Term calls to USBUART calls.
	#if defined(CY_USBFS_`$INSTANCE_NAME`_USBUART_H)	// Only allow the defines and prototypes below if UART.h is not defined.
// Conversion of UART-equivalent calls to USBUART calls.
/* Function Prototypes
*/
void `$INSTANCE_NAME`_USBUART__PutString(const char8 string[]);
void `$INSTANCE_NAME`_USBUART__PutArray(char8 string[], uint16 byteCount);
void `$INSTANCE_NAME`_USBUART__PutChar(uint8 c);
void `$INSTANCE_NAME`_USBUART__PutCRLF(uint8 c);
void `$INSTANCE_NAME`_USBUART__ClearRxBuffer();
uint8 `$INSTANCE_NAME`_USBUART__ReadRxData();
uint8 `$INSTANCE_NAME`_USBUART__GetChar();
uint8 `$INSTANCE_NAME`_USBUART__GetRxBufferSize();

// Term function re-directs defines
#define `$INSTANCE_NAME`_PutString			`$INSTANCE_NAME`_USBUART__PutString
#define `$INSTANCE_NAME`_PutArray 			`$INSTANCE_NAME`_USBUART__PutArray 
#define `$INSTANCE_NAME`_PutChar  			`$INSTANCE_NAME`_USBUART__PutChar  
#define `$INSTANCE_NAME`_PutCRLF  			`$INSTANCE_NAME`_USBUART__PutCRLF  
#define `$INSTANCE_NAME`_Stop				`$INSTANCE_NAME`_USBUART__Stop
#define `$INSTANCE_NAME`_ClearRxBuffer		`$INSTANCE_NAME`_USBUART__ClearRxBuffer	
#define `$INSTANCE_NAME`_GetRxBufferSize	`$INSTANCE_NAME`_USBUART__GetRxBufferSize
#define `$INSTANCE_NAME`_ReadRxData			`$INSTANCE_NAME`_USBUART__ReadRxData		
#define `$INSTANCE_NAME`_GetChar			`$INSTANCE_NAME`_USBUART__GetChar
		
// More #defines substitution can be added later as needed

// The following is used, if desired, to monitor the UART_USB ISR access and timing. 
// To monitor, allocate a PSoC output pin with the same name (eg.  PIN_USB_ARB_ISR)
#if !defined(CY_PINS_PIN_USB_ARB_ISR_H) // Pin not declared 
	#define PIN_USB_ARB_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_EP0_ISR_H) 	// Pin not declared
	#define PIN_USB_EP0_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_EP1_ISR_H) 	// Pin not declared
	#define PIN_USB_EP1_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_EP2_ISR_H) 	// Pin not declared
	#define PIN_USB_EP2_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_EP3_ISR_H) 	// Pin not declared
	#define PIN_USB_EP3_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_BUS_RESET_ISR_H) 	// Pin not declared
	#define PIN_USB_BUS_RESET_ISR_Write(a)	// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_DP_ISR_H) 	// Pin not declared
	#define PIN_USB_DP_ISR_Write(a)		// Use dummy Write()
#endif
#if !defined(CY_PINS_PIN_USB_SOF_H) 	// Pin not declared
	#define PIN_USB_SOF_Write(a)		// Use dummy Write()
#endif
	#endif		// #if !defined(CY_UART_`$INSTANCE_NAME`_USBUART_H)
	
#endif 		// #if !defined(`$INSTANCE_NAME`_H)
/* [] END OF FILE */
